C **********************************************************************
C *                                                                    *
C *                                SOFTWARE LICENSING                  *
C *                                                                    *
C *                This program is free software; you can redistribute *
C *                it and/or modify it under the terms of the GNU      *
C *                General Public License as published by the Free     *
C *                Software Foundation, either Version 2 of the        *
C *                license, or (at your option) any later version.     *
C *                                                                    *
C *                This program is distributed in the hope that it     *
C *                will be useful, but without any warranty; without   *
C *                even the implied warranty of merchantability or     *
C *                fitness for a particular purpose. See the GNU       *
C *                General Public License for more details.            *
C *                                                                    *
C *                A copy of the GNU General Public License is         *
C *                available at http://www.gnu.org/copyleft/gpl.html   *
C *                or by writing to the Free Software Foundation, Inc.,*
C *                59 Temple Place - Suite 330, Boston, MA 02111, USA. *
C *                                                                    *
C **********************************************************************

      SUBROUTINE CHEMFLX
C
C  CALCULATES DEPOSITION AND DEPOSITION FLUXES OF CHEM AT
C  SEDIMENT-WATER INTERFACE
C
C  REVISION DATE :  APRIL 18, 1996
C
C**********************************************************************
C
      INCLUDE 'comdeck'
C
C
C  CLASS 1 & 2 SEDIMENTS:  FLUX IN ug CHEM/cm**2
C
C  CBEDCHEM = BED CONC. IN LAYER 1 (ug CHEM/g SOLIDS)
C
C  COHESIVE ELEMENTS
C
      DO 10 J=2,JMM1
        DO 10 I=2,IMM1
          CHEMBOT1(I,J)=0.0
          CHEMBOT2(I,J)=0.0
C
          IF (FSM(I,J).GT.0.0) THEN
C
C  EROSION FROM LAYER 1
C
            CHEMBOT1(I,J)=CBEDCHEM(1,I,J)*E(1,I,J)
            CHEMBOT2(I,J)=CBEDCHEM(1,I,J)*E(2,I,J)
C
C  DEPOSITION
C
            IF (CSED1(I,J,KBM1).GT.0.0) THEN
              CHEMBOT1(I,J)=CHEMBOT1(I,J)-
     +                   DD(1,I,J)*CHEM1(I,J,KBM1)/CSED1(I,J,KBM1)
            ENDIF
C
            IF (CSED2(I,J,KBM1).GT.0.0) THEN
              CHEMBOT2(I,J)=CHEMBOT2(I,J)-
     +                   DD(2,I,J)*CHEM2(I,J,KBM1)/CSED2(I,J,KBM1)
            ENDIF
          ENDIF
 10   CONTINUE
C
      RETURN
      END
