C **********************************************************************
C *                                                                    *
C *                                SOFTWARE LICENSING                  *
C *                                                                    *
C *                This program is free software; you can redistribute *
C *                it and/or modify it under the terms of the GNU      *
C *                General Public License as published by the Free     *
C *                Software Foundation, either Version 2 of the        *
C *                license, or (at your option) any later version.     *
C *                                                                    *
C *                This program is distributed in the hope that it     *
C *                will be useful, but without any warranty; without   *
C *                even the implied warranty of merchantability or     *
C *                fitness for a particular purpose. See the GNU       *
C *                General Public License for more details.            *
C *                                                                    *
C *                A copy of the GNU General Public License is         *
C *                available at http://www.gnu.org/copyleft/gpl.html   *
C *                or by writing to the Free Software Foundation, Inc.,*
C *                59 Temple Place - Suite 330, Boston, MA 02111, USA. *
C *                                                                    *
C **********************************************************************

      SUBROUTINE LONGWAVE(SST,TAIR,EA,C,RL1,RL2,RLW,RLWC)
CMNT  COMPUTE CLEAR SKY LONGWAVE, RLW, AFTER (CLARKE ET AL,
CMNT  1974) AND CLOUD CORRECTED LONGWAVE, RLWC.
CMNT  INPUT SST (DEG C), TAIR (DEG C), VAPOR PRESSURE (MB),
CMNT  AND CLOUD COVER (DECIMAL, 0 TO 1.0).  EMISSIVITY
CMNT  IS ASSUMED TO BE 0.98; SIGMA=STEFAN-BOLTZMANN CONST.
CMNT
CMNT  R.WELLER, 6/18/87
CMNT
      EPS=0.98
      SIGMA=5.67E-08
      TKEL=273.16
      SSTK=SST+273.16
      TAIRK=TAIR+TKEL
      TS4=SSTK**4.
      TS3=SSTK**3.
      DT=SSTK-TAIRK
      EASQR=SQRT(EA)
      RL1=(EPS*SIGMA*TS4*(0.39-(0.05*EASQR)))
      RL2=4.*EPS*SIGMA*TS3*DT
      RLW=RL1+RL2
CMNT  COMPUTE CLOUD CORRECTION FACTOR (CLARKE ET AL 1974)
CMNT  B=0.62 HARDWIRED FOR 27 DEG NORTH
      B=0.62
      CSQ=C*C
      FC=1-(B*CSQ)
      RLWC=RLW*FC
      RETURN
      END
