C **********************************************************************
C *                                                                    *
C *                                SOFTWARE LICENSING                  *
C *                                                                    *
C *                This program is free software; you can redistribute *
C *                it and/or modify it under the terms of the GNU      *
C *                General Public License as published by the Free     *
C *                Software Foundation, either Version 2 of the        *
C *                license, or (at your option) any later version.     *
C *                                                                    *
C *                This program is distributed in the hope that it     *
C *                will be useful, but without any warranty; without   *
C *                even the implied warranty of merchantability or     *
C *                fitness for a particular purpose. See the GNU       *
C *                General Public License for more details.            *
C *                                                                    *
C *                A copy of the GNU General Public License is         *
C *                available at http://www.gnu.org/copyleft/gpl.html   *
C *                or by writing to the Free Software Foundation, Inc.,*
C *                59 Temple Place - Suite 330, Boston, MA 02111, USA. *
C *                                                                    *
C **********************************************************************

      FUNCTION QSAT(T,P)
C
C        T         temperature in degrees C
C        P         pressure in millibars
C        ES        saturation vapor pressure in millibars
C        QSAT      saturation humidity in g/kg 
C
      RD = 287.05
      RV = 461.5

      EPS = RD/RV

C*********Saturation vapor pressure**********
      ES = (1.0007+3.46E-6*P) * 6.1121 * EXP(17.502 * T/ (240.97 + T))

C*********Convert to saturation humidity*****
      QSAT = 1000. * EPS * ES / ( P + ES * (EPS - 1.0))

      RETURN
      END          
