C **********************************************************************
C *                                                                    *
C *                                SOFTWARE LICENSING                  *
C *                                                                    *
C *                This program is free software; you can redistribute *
C *                it and/or modify it under the terms of the GNU      *
C *                General Public License as published by the Free     *
C *                Software Foundation, either Version 2 of the        *
C *                license, or (at your option) any later version.     *
C *                                                                    *
C *                This program is distributed in the hope that it     *
C *                will be useful, but without any warranty; without   *
C *                even the implied warranty of merchantability or     *
C *                fitness for a particular purpose. See the GNU       *
C *                General Public License for more details.            *
C *                                                                    *
C *                A copy of the GNU General Public License is         *
C *                available at http://www.gnu.org/copyleft/gpl.html   *
C *                or by writing to the Free Software Foundation, Inc.,*
C *                59 Temple Place - Suite 330, Boston, MA 02111, USA. *
C *                                                                    *
C **********************************************************************

      SUBROUTINE VAPOR(EA,ES,RH,SST,BP,SAL)
C
CMNT  RH IN PERCENT, SST IN DEG C, BP IN MB
CMNT  COMPUTE VAPOR PRESSURE OF WATER FROM RELATIVE
CMNT  HUMIDITY
CMNT
CMNT  R.WELLER, 6/18/87
CMNT
CMNT  COMPUTE SATURATION VAPOR PRESSURE OF PURE WATER
CMNT  USING TABATA FORMULA
C**********************************************************
C       Modified November 6, 1990       M. Park Samelson
C       
C       Previously used Tabata formula (1973).  This
C       version uses Buck formula (1981).  Temperature
C       is in degrees C instead of degrees K.
C
C**********************************************************

C*******Tabata formula**************
C**** TK=273.16
C**** SSTK=SST+TK
C**** A=1000./SSTK
C**** E=8.42926609-(1.82717483*A)-(.071208271*A*A)
C**** ES=10.**E

C********Buck formula***************
CNG It calculates water vapor (partial) pressure of saturated moist air
CNG Original Buck (1981) used up to 2011, below:
CNG            ES = (1.0007+3.46E-6*BP)*6.1121*EXP(17.502 * SST/ (240.97 + SST))
CMNT  CORRECT FOR SALT WATER AT 35 PPT (CNG10252011 Why HARDWIRE at 35ppt?????)
CNG            EW=.9815*ES
CNGforIce      Note: this would be the following with respect to plane surface of ice:
CNGforIceUse:  ES = (1.0003+4.18E-6*BP)*6.1115*EXP(22.452 * SST/ (272.55 + SST))

CNG10252011 New Buck (1996) adopted below:
      ES = (1.0007+3.46E-6*BP)*6.1121*
     .     EXP( (18.677 - SST/234.50) * (SST/(257.14 + SST)) )
CNG10252011 Corrected for actual salinity based on, for example,
CNG10252011 List, R.J. (1984) Smithsonian Meteorological Tables. Sixth ed. Washington, 
CNG10252011 D.C.: Smithsonian Institution Press, 527 p
      EW = ES*(1 - 0.000537*SAL)
CNG10262011IfForIce      ES = (1.0003+4.18E-6*BP)*6.1121*
CNG10262011IfForIce     .     EXP( (23.036 - SST/333.70) * (SST/(279.82 + SST)) )
CNG10262011IfForIce      EW=ES ! No salinity correction (ice rejects salt)

CMNT  COMPUTE SATURATION MIXING RATIO
      B=EW/BP
      RW=(B*.62197)/(1.-B)
CMNT  COMPUTE MIXING RATIO
      R=(RH/100.)*RW
CMNT  COMPUTE VAPOR PRESSURE
      EA=(R/(.62197+R))*BP
      RETURN
      END
